local function addAuraSource(self, func, unit, index, filter)
	local sourceUnit = select(8, func(unit, index, filter))
	if sourceUnit then
		if sourceUnit == "pet" or sourceUnit == "vehicle" then
			sourceUnit = "player"
		else
			local groupType = sourceUnit:match("^(party)pet%d+$") or sourceUnit:match("^(raid)pet%d+$")
			if groupType then
				sourceUnit = groupType..sourceUnit:match("pet(%d+)$")
			end
		end
		
		self:AddLine(" ")
		self:AddLine(GetUnitName(sourceUnit, true))
		self:Show()
	end
end

local funcs = {
	SetUnitAura = UnitAura,
	SetUnitBuff = UnitBuff,
	SetUnitDebuff = UnitDebuff,
}

for k, v in pairs(funcs) do
	hooksecurefunc(GameTooltip, k, function(self, unit, index, filter)
		addAuraSource(self, v, unit, index, filter)
	end)
end